/*
  yasep/ASM/test_opcodes.js created by whygee at f-cpu.org
  This file is distributed under terms of the Affero GPL v3 license or later, see http://yasep.org
  created 2007-04-01 from opcode_map.html
  2007-04-04 : moved all the JS stuff to vspsim/test/test_opcodes.js
  2007-04-08 : aliases included and converted
  2007-04-09 : some more cleanup
  2007-04-11 : added various details.
  2007-04-17 : updated for new flags
  2007-11-05 : YASEP rebranding, support of the flags IMM16_5LSB and IMM16_8LSB
  2009-07-10 : adapted for js_list2
  2009-07-28 : Y
  2009-08-10 : new disassembler
  2009-08-23 : it's working again !
  2011-09-08 : moved from benches/test_opcodes.html and turned into an autonomous window.
  2011-09-11 : big changes !
  2012-09-27 : added scan_examples

  This file exercises the assembler and disassembler and searches inconsistencies
*/

init_obj.push(test_opcodes={
  win:null,
  chunks:12, // how many instructions before a page redraw
  HTML:"",
  // start creates other variables

  add_message: function(col,msg){
    test_opcodes.HTML +='      <span style="background-color:'+col+'">'+(test_opcodes.msg_number++)+"</span>: "+msg+"\n";
  },

  scan_examples: function(){
    if (test_opcodes.cur_opcode<list_yas.length){
      winman.activate_window("ASM/impASM#examples/"+list_yas[test_opcodes.cur_opcode++]+".yas");
      setTimeout(test_opcodes.scan_examples,5);
    }
  },

  test_opcode: function(x) {
    var a=' <a id="end_error" name="end_error"> ';
    test_opcodes.HTML+='  <a class="asm_active" onclick="wa(\'ASM/asm#a?'+x+'\')" href="#!ASM/asm#a?'+x+'">'+x+"</a>\n";
    if (Y.encode_instruction(x,test_opcodes.ASM)) {
      Y.DISASM(test_opcodes.ASM.encoded_instruction,test_opcodes.DISASM);
      if (test_opcodes.DISASM.instruction != x) {
        // putting the <a> tag here should force the browser to go to the first error in the list
        test_opcodes.add_message("red",a+"output != input</a>");
        test_opcodes.errnum++;
      }
    }
    else {
      test_opcodes.add_message("red",a+"error </a>");
      test_opcodes.errnum++;
    }
  },

  scan_opcode_table: function() {
    if (test_opcodes.cur_opcode>=test_opcodes.max_opcode) { // last opcode scanned ?
      if (test_opcodes.errnum > 0) {
        test_opcodes.win.shortmsg(I8N("tcw")+test_opcodes.errnum+I8N("rs"));
        document.location.href="#end_error";  // focus qui marche
        YGCSS.changeTheme(test_opcodes.win, "doc_red")
      }
      else {
        test_opcodes.win.shortmsg(I8N("Ts"));
        YGCSS.changeTheme(test_opcodes.win, "doc_gryl")
      }

      if (window.list_yas){
        test_opcodes.cur_opcode=0;
        test_opcodes.scan_examples();
      }
    }
    else {
      test_opcodes.HTML="";
      var chunk=test_opcodes.chunks; // display "chunks" <pre> at a time
      while ((chunk > 0) && (test_opcodes.cur_opcode<test_opcodes.max_opcode)) {
        chunk--;

        var name=test_opcodes.sorted_opcodes[test_opcodes.cur_opcode++]; // also gets rid of aliases
        var index=Y.table_opcode[name].val;
        var instr=Y.opcode_table[index];

        test_opcodes.HTML+="<hr>"+int2hex(index)+' : <a href="ISM/'+name+'.html">'
               +name+'</a>    "<i>'+instr.description+'"</i>\n';

        // Scan the forms list
        var f=instr.forms;
        var i=1;

        do {
          if (f & i) {
            var j=Y.TableForm[i];
            var k=j.replace(/FORM_/,"");
            var v=' -<a href="#docs/instructions.html#'+k+'">'+j+"</a>";

            var w=Y.TableEncoders[j].ex(instr.flags, name); // random operands
            if (w=="") // no operands so don't add a spacer that will bork the instruction
              w=instr.name;
            else 
              w=instr.name+" "+w;
            test_opcodes.HTML+=v+"\n";

            test_opcodes.test_opcode(w);

            if ((i & Y.FORMS_EXTENDABLE)&&((instr.flags & Y.NO_CONDITION)==0))
              test_opcodes.test_opcode(w+" "+Y.randomCondition());
          }
          i<<=1;
        } while (i <= f);
      } // while chunk>0...
      var new_pre = dcE("pre");
      new_pre.innerHTML=test_opcodes.HTML;
      test_opcodes.win.contents_id.firstChild.appendChild(new_pre);

      setTimeout(test_opcodes.scan_opcode_table,5);
    }
  },

  start: function() {
    // (re-)initialise important variables
    test_opcodes.msg_number=0;
    test_opcodes.errnum=0;
    test_opcodes.sorted_opcodes=[];
    test_opcodes.max_opcode=0;
    test_opcodes.cur_opcode=0;

    test_opcodes.win= ygwm.new_window( "", null, "none",
       650, Math.ceil((getHeight()*3)/4),
       100, 50, false, true, true, true, false);

    test_opcodes.win.contents_id.firstChild.innerHTML=import_htmi("ASM/test_opcodes");
    winman.patchInnerLinks(test_opcodes.win.contents_id);
    var h=getByClass("hiddenDiv","DIV", test_opcodes.win.contents_id);
    ygwm.changeWinTitle(test_opcodes.win, hiddenText(0,h));

    test_opcodes.ASM   = new    Y.ASM_context(test_opcodes.add_message);
    test_opcodes.ASM.YASEP_TYPE=32; // => IMM20 works
    test_opcodes.DISASM= new Y.DISASM_context(test_opcodes.add_message);

    // prepare the sorted list of opcodes
    for (var name in Y.table_opcode) {
      if ((Y.table_opcode[name].forms>0)
      && (typeof Y.opcode_aliases[name]) == "undefined") // check it's not an alias
        test_opcodes.sorted_opcodes[test_opcodes.max_opcode++]=name;
    }
    test_opcodes.sorted_opcodes=test_opcodes.sorted_opcodes.sort();
    test_opcodes.win.shortmsg(I8N("rng"));
    setTimeout(test_opcodes.scan_opcode_table,50);

    return test_opcodes.win;
  },

  init_obj: function() {
    menu.subMenuItem(menu.list["ASM"], i8n.ats, "ASM/test_opcodes");
  }
});
